freeslot("SPR2_SHIT", "SPR_RGLK", "S_ROSEGOLD_LOCKON",
"SKINCOLOR_SUPERROSY1",
"SKINCOLOR_SUPERROSY2",
"SKINCOLOR_SUPERROSY3",
"SKINCOLOR_SUPERROSY4",
"SKINCOLOR_SUPERROSY5")

skincolors[SKINCOLOR_SUPERROSY1] = {
	name = "Super Rosy 1",
	ramp = {00,00,00,00,00,00,00,00,00,00,00,252,252,200,201,201},
	accessible = false
}

skincolors[SKINCOLOR_SUPERROSY2] = {
	name = "Super Rosy 2",
	ramp = {00,00,00,00,00,00,00,00,252,252,200,200,200,201,202,202},
	accessible = false
}

skincolors[SKINCOLOR_SUPERROSY3] = {
	name = "Super Rosy 3",
	ramp = {00,00,00,00,00,252,252,200,200,200,201,201,202,202,203,203},
	accessible = false
}

skincolors[SKINCOLOR_SUPERROSY4] = {
	name = "Super Rosy 4",
	ramp = {00,00,00,252,252,200,200,200,201,201,202,202,203,203,204,204},
	accessible = false
}

skincolors[SKINCOLOR_SUPERROSY5] = {
	name = "Super Rosy 5",
	ramp = {00,252,252,200,200,200,201,201,202,202,203,203,204,204,205,205},
	accessible = false
}

states[S_ROSEGOLD_LOCKON] = {
	sprite = SPR_RGLK,
	frame = A|FF_ANIMATE|FF_FULLBRIGHT|FF_GLOBALANIM,
	var1 = 4,
	var2 = 3,
	tics = 2,
}

spr2defaults[SPR2_SHIT] = SPR2_PAIN

-- particle effects

local function RGA_colorizer(p, b, c)
	b.flags = $ | MF_NOCLIP
	b.colorized = true
	if c != nil
	and R_GetColorByName(c) != SKINCOLOR_NONE
		b.color = R_GetColorByName(c)
	else
		b.color = ColorOpposite(p.mo.color)
	end
end

local function RGA_funnyExplode(mo)
	if mo and mo.valid
		for i = 1, 64
			if i <= 32 --we'll have 32 thok-based booms
				local boom2 = P_SpawnMobjFromMobj(mo, P_RandomRange(-25, 25)*FRACUNIT,
				P_RandomRange(-25, 25)*FRACUNIT,
				P_RandomRange(-25, 25)*FRACUNIT,
				MT_THOK)
				boom2.tics = TICRATE*2
				boom2.boomer = true --we'll attach a separate hook to this mobj
				P_InstaThrust(boom2, FixedAngle(P_RandomRange(0, 360)*FRACUNIT), P_RandomRange(5, 10)*FRACUNIT)
				boom2.momz = P_RandomRange(5, 10)*FRACUNIT*P_MobjFlip(boom2)
				boom2.flags = MF_NOCLIPHEIGHT|MF_NOCLIP
				boom2.destscale = 0
				boom2.scalespeed = FRACUNIT/(TICRATE*2)
				boom2.color = SKINCOLOR_YELLOW
			else
				local boom2 = P_SpawnMobjFromMobj(mo, P_RandomRange(-60, 60)*FRACUNIT,
				P_RandomRange(-60, 60)*FRACUNIT,
				P_RandomRange(-60, 60)*FRACUNIT,
				P_RandomChance(FRACUNIT/2) and MT_BOSSEXPLODE or MT_SONIC3KBOSSEXPLODE)--50% chance of spawning either
				boom2.tics = $ + P_RandomRange(0, 10) --asking for a bit more variety
				boom2.scale = $ + P_RandomRange(0, FRACUNIT/2)
			end
		end
	end		
end

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.boomer
		local colors = {SKINCOLOR_YELLOW, SKINCOLOR_APRICOT, SKINCOLOR_ORANGE, SKINCOLOR_FLAME, 
						SKINCOLOR_CRIMSON, SKINCOLOR_SILVER, SKINCOLOR_JET, SKINCOLOR_BLACK}
		local colortimes = {70, 64, 60, 50, 40, 30, 20, 10}
		local asplodeTrail = P_SpawnGhostMobj(mo)
		asplodeTrail.destscale = 0
		asplodeTrail.blendmode = AST_ADD
		for i = 1, #colortimes
			if mo.tics == colortimes[i]
				mo.color = colors[i]
			end
		end
	end
end, MT_THOK)

local function SpawnParticles(p, v, c)
	if v != 4
		for i = 1, 8
			local bam = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, ({MT_BOXSPARKLE,MT_SPINFIRE,MT_DUST})[v])
			if v == 1
				bam.rga_bam = true
			elseif v == 2
				bam.flags = $ & ~ (MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY)
				bam.fuse = TICRATE*6
			elseif v == 3
				bam.frame = $ | TR_TRANS60
			end
			bam.scale = p.mo.scale*(v==1 and 2 or 1)
			if v != 2
				RGA_colorizer(p, bam, c)
			end
			P_InstaThrust(bam, (i*ANGLE_45), ({2,3,5})[v]*bam.scale)
			P_SetObjectMomZ(bam, ({2,-5,-5})[v]*FRACUNIT, false)
		end
	else
		for i = 1, 4
			local bam = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, MT_THUNDERCOIN_SPARK)
			bam.scale = p.mo.scale
			bam.fuse = TICRATE/3
			RGA_colorizer(p, bam, c)
			P_InstaThrust(bam, (i*ANGLE_90), 2*bam.scale)
			P_SetObjectMomZ(bam, -10*FRACUNIT, false)
		end
	end
end--funny particle effect go brrrrrrrr

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.rga_bam
			mo.rollangle = $ + FixedAngle(22*FRACUNIT)
			mo.momx = $ - FRACUNIT/10
			mo.momy = $ - FRACUNIT/10
			mo.momz = $ - FRACUNIT/10
			mo.destscale = 0
		end 
	end
end, MT_BOXSPARKLE)

-- gameplay stuffs

local function RunDefaultAbility(p, v) --default non-shield abilities
	v = tonumber($)
	p.pflags = $ | P_GetJumpFlags(p)
	P_SetObjectMomZ(p.mo, ({25,15,-20,15})[v]*FRACUNIT, false)
	if v == 1
		SpawnParticles(p, 1)
		p.rga.dothing = false
	elseif v == 2
		p.pflags = $ & ~PF_THOKKED
		P_BounceMove(p.mo)
	elseif v == 3
		if (p.cmd.forwardmove or p.cmd.sidemove)
			if p.isxmomentum 
				P_InstaThrust(p.mo, p.mo.angle, (25*p.mo.scale) + p.speed)
			else
				P_InstaThrust(p.mo, p.mo.angle, 65*p.mo.scale)
			end
		end
		p.pflags = $ | PF_THOKKED
		S_StartSound(p.mo, sfx_s3k42)
		p.drawangle = p.mo.angle
	end
end

local function ShieldAction(p, v)
	v = tonumber($)
	local shield = (p.powers[pw_shield] & SH_NOSTACK)
	p.pflags = $ | P_GetJumpFlags(p)	
	//default shit cuz i cant remember how lmao
	
	if v != 3
		p.rga.cantspin = false
	else
		p.pflags = $ & ~PF_THOKKED
	end //lol	
	
	if shield == SH_ARMAGEDDON
		if v != 2
			SpawnParticles(p, 1)
		end
		if v != 3
			P_BlackOw(p)
		end
		P_SetObjectMomZ(p.mo, ({35,15,-30,25})[v]*FRACUNIT, false)
		if v == 1
			p.rga.dothing = false
		elseif v == 2
			RunDefaultAbility(p, v)
		elseif v == 3
			if (p.cmd.forwardmove or p.cmd.sidemove)
				if p.isxmomentum
					P_InstaThrust(p.mo, p.mo.angle, (50*p.mo.scale) + p.speed)
				else
					P_InstaThrust(p.mo, p.mo.angle, 80*p.mo.scale)
				end
			end
			p.pflags = $ | PF_THOKKED
			S_StartSound(p.mo, sfx_s3k42)
			p.drawangle = p.mo.angle
		end
	elseif shield == SH_ATTRACT
		if v == 1
			SpawnParticles(p, 4, "gold")
			p.rga.dothing = false
			P_SetObjectMomZ(p.mo, 30*FRACUNIT, false)
		elseif v == 3
			P_SetObjectMomZ(p.mo, -90*FRACUNIT, false)
			SpawnParticles(p, 4, "gold")
			S_StartSound(p.mo, sfx_s3k40)
			if (p.cmd.forwardmove or p.cmd.sidemove)
				if p.isxmomentum
					P_InstaThrust(p.mo, p.mo.angle, (25*p.mo.scale) + p.speed)
				else
					P_InstaThrust(p.mo, p.mo.angle, 65*p.mo.scale)
				end
			end
			p.pflags = $ | PF_THOKKED
			S_StartSound(p.mo, sfx_s3k42)
			p.drawangle = p.mo.angle
		elseif v == 4
			local r = P_LookForEnemies(p, true, true)
			if r and r.valid
				local lockonangle = R_PointToAngle2(p.mo.x, p.mo.y, r.x, r.y)
				p.mo.angle = lockonangle --Look at the enemy
				p.drawangle = lockonangle --Do it now
				local xdiff = r.x-p.mo.x
				local ydiff = r.y-p.mo.y
				local zdiff = r.z-p.mo.z
				p.mo.momx = xdiff/6
				p.mo.momy = ydiff/6
				p.mo.momz = zdiff/6
				S_StartSound(p.mo, sfx_s3k40)
				p.rga.dothing = false
				local lmao = P_SpawnGhostMobj(p.mo)
				lmao.destscale = 0
				lmao.blendmode = AST_ADD
				lmao.flags = $ | FF_FULLBRIGHT
			else
				RunDefaultAbility(p, v)
				SpawnParticles(p, 4, "gold")
				S_StartSound(p.mo, sfx_s3ka6)
			end
		else
			RunDefaultAbility(p, v)
		end
	elseif shield == SH_FLAMEAURA or shield == SH_ELEMENTAL
		if v != 2
			P_SetObjectMomZ(p.mo, ({7,nil,-40,25})[v]*FRACUNIT, false)
			if p.isxmomentum
				P_InstaThrust(p.mo, p.mo.angle, (({55,nil,50,20})[v]*p.mo.scale) + p.speed)
			else
				P_InstaThrust(p.mo, p.mo.angle, ({75,nil,70,40})[v]*p.mo.scale)
			end
			p.drawangle = p.mo.angle
		end
		if v == 1
			P_ElementalFire(p, true)
			S_StartSound(p.mo, sfx_s3k43)
		elseif v == 4
			SpawnParticles(p, 2)
		else
			RunDefaultAbility(p, v)
		end
	elseif (shield == SH_THUNDERCOIN or shield == SH_WHIRLWIND)
		if v == 1
			p.rga.dothing = false
		end
		if v == 1
		or v == 4
			if shield == SH_THUNDERCOIN
				SpawnParticles(p, 4, "aether")
				S_StartSound(p.mo, sfx_s3k45)
			else
				SpawnParticles(p, 3, "cloudy")
				P_Thrust(p.mo, p.mo.angle, 10*p.mo.scale)
			end
		else
			RunDefaultAbility(p, v)
		end
		P_SetObjectMomZ(p.mo, ({35,25,-30,25})[v]*FRACUNIT, false)
	elseif shield == SH_BUBBLEWRAP
		if v == 1
			P_SetObjectMomZ(p.mo, 35*FRACUNIT, false)
			p.rga.dothing = false
			SpawnParticles(p, 1, "sapphire")
		elseif v == 3
			P_SetObjectMomZ(p.mo, -50*FRACUNIT, false)
			if (p.cmd.forwardmove or p.cmd.sidemove)
				if p.mo.eflags & MFE_UNDERWATER
					P_InstaThrust(p.mo, p.mo.angle, 20*p.mo.scale)
				else
					P_InstaThrust(p.mo, p.mo.angle, 50*p.mo.scale)
				end
			end
			p.pflags = $ | PF_THOKKED
			S_StartSound(p.mo, sfx_s3k42)
			p.drawangle = p.mo.angle
		else
			RunDefaultAbility(p, v)
		end
	else
		RunDefaultAbility(p, v)
	end
end

local function RGA_doubleJump(p)	
	if not (p.pflags & PF_SLIDING)
		p.pflags = ($ & ~ PF_STARTJUMP)|($ | PF_THOKKED)
		p.mo.frame = A
		p.mo.state = S_PLAY_TWINSPIN
		p.rga.dothing = true
		p.rga.cantspin = false
		S_StartSound(p.mo, sfx_s3k42)
		ShieldAction(p, 4)
	end
end

-- proper thinker
//TODO: REWRITE THIS
addHook("ThinkFrame", do
	for p in players.iterate
		if p.mo and p.mo.valid
			if p.mo.skin == "rosegoldamy"
				if not p.rga
					local rosegold = {
						rga_jumpdown = false,
						rga_spindown = false,
						rga_dumb = false,
						cantspin = false,
						dothing = false,
						rgafunny = false,
						prevcarry = 0,
					}
					p.rga = rosegold
				end
				p.isuselesschar = true
				if p.playerstate == PST_LIVE --Bwap, living gives you power
					
					p.mo.spark = P_SpawnMobjFromMobj( --oooh, shiny
						p.mo,
						P_RandomRange(-50, 50)*FRACUNIT,
						P_RandomRange(-50, 50)*FRACUNIT,
						P_RandomRange(-50, 50)*FRACUNIT,
						MT_BOXSPARKLE
					)
					
					if p.mo.spark and p.mo.spark.valid
						p.mo.spark.momx = p.mo.momx
						p.mo.spark.momy = p.mo.momy
						p.mo.spark.momz = p.mo.momz
						p.mo.spark.colorized = true --Time to determine the sparkle's color
						if p.rga.dothing
						or (p.pflags & PF_THOKKED and p.pflags & PF_JUMPED and not p.rga.cantspin)
							p.mo.spark.color = ColorOpposite(p.mo.color)
						else
							p.mo.spark.color = p.mo.color
						end --Sparkles change when you can/cannot use your hammer
					end
					
					if p.powers[pw_carry] != CR_NIGHTSMODE						
						if p.pflags & PF_JUMPED
						and not p.rga.dothing
						and (p.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
							local enemy = P_LookForEnemies(p, true, true)
							if enemy and enemy.valid
								P_SpawnLockOn(p, enemy, S_ROSEGOLD_LOCKON)
							end
						end
						
						if p.powers[pw_carry]
							p.rga.rgafunny = true
							local cr = p.powers[pw_carry]
							p.rga.prevcarry = cr
							if ((p.cmd.buttons & BT_SPIN) and not p.rga.rga_spindown)
								if cr == CR_MINECART
									p.mo.tracer.target = nil
									P_KillMobj(p.mo.tracer, p.mo, inflictor, 0)
									p.mo.tracer = nil
									p.powers[pw_carry] = CR_NONE
									p.mo.state = S_PLAY_MELEE_LANDING
								end
							end
						else
							if p.rga.rgafunny
								p.rga.rgafunny = false
								p.rga.dothing = false
								p.rga.cantspin = false
								p.pflags = ($ & ~PF_THOKKED)|($|P_GetJumpFlags(p))
							end
							--im going to have a die
							if p.rga.prevcarry
							and P_IsObjectOnGround(p.mo)
								p.rga.prevcarry = 0
								p.pflags = $ & ~PF_JUMPED
							end
							p.rga.prevcarry = 0
						end
						
						if p.mo.state == S_PLAY_ROLL
							if p.rga.rga_dumb
								p.pflags = $ | P_GetJumpFlags(p)
							end
						else
							p.rga.rga_dumb = false
						end
						
						if p.rga.cantspin
						and p.mo.state == S_PLAY_TWINSPIN
						and (p.mo.frame&FF_FRAMEMASK) < E
							local lmao = P_SpawnGhostMobj(p.mo)
							lmao.destscale = 0
							lmao.blendmode = AST_ADD
							lmao.flags = $ | FF_FULLBRIGHT
							lmao.momx = p.mo.momx/3
							lmao.momy = p.mo.momy/3
							lmao.momz = p.mo.momz/3
						end
						if p.mo.eflags & MFE_SPRUNG
						or ( (not P_IsObjectOnGround(p.mo)) and (
						p.mo.state == S_PLAY_STND
						or p.mo.state == S_PLAY_WAIT
						or p.mo.state == S_PLAY_WALK
						or p.mo.state == S_PLAY_RUN)
						or (p.mo.state == S_PLAY_PAIN and not (p.pflags & PF_SLIDING)))
						and not p.powers[pw_carry]
							p.rga.dothing = false
							p.rga.cantspin = false
							p.pflags = $ | P_GetJumpFlags(p)
							p.pflags = $ & ~PF_THOKKED
							if not ((p.mo.eflags & MFE_SPRUNG) or (p.mo.state == S_PLAY_PAIN))
								p.mo.state = (p.mo.z >= 1*P_MobjFlip(p.mo)) and S_PLAY_JUMP or S_PLAY_FALL
							end
							if p.mo.state == S_PLAY_PAIN
							and p.cmd.buttons & BT_JUMP
							and not p.rga.rga_jumpdown
								RGA_doubleJump(p)
							end
						end --Springing allows you to hammer
						if (p.mo.eflags & MFE_ONGROUND
						and p.mo.eflags & MFE_JUSTHITFLOOR)
						or P_IsObjectOnGround(p.mo)
						or not (p.pflags & PF_THOKKED)
							p.rga.dothing = false
							p.rga.cantspin = false
						end --reset this when something happens, allows the other hooks using dothing to run
						if p.mo.state == S_PLAY_MELEE_LANDING --Finished the melee?
							p.rga.cantspin = false //for some reason this var is stupid
							p.rga.rga_dumb = true
							S_StartSound(p.mo,sfx_pstop)
							local px = p.mo.x
							local py = p.mo.y
							local br = 250*p.mo.scale
							searchBlockmap("objects", function(mo, found)
								if found and found.valid
								and abs(mo.z - found.z) <= 500*mo.scale
								and found.health
								and found.type != MT_EGGMAN_BOX
								and found.type != MT_EGGMAN_GOLDBOX
									if found.flags & MF_MONITOR --Kills multi-hit enemies and monitors!
									or found.type == MT_CYBRAKDEMON_ELECTRIC_BARRIER --Ruins brak, he's powerless against you!
									or found.type == MT_SPIKE --Endlessly harrass spikes!
									or found.type == MT_WALLSPIKE --Endlessly harrass spikes! X2
									or found.type == MT_WALLSPIKEBASE --Endlessly harrass spikes! X3
									or found.type == MT_EGGSHIELD //lol
										P_KillMobj(found, mo, mo)
									elseif found.type == MT_METALSONIC_BATTLE
									and found.state == S_METALSONIC_FLOAT
										found.flags2 = $ | MF2_CLASSICPUSH --Endlessly harrass metal sonic too!
									elseif found.flags & MF_BOSS|MF_SHOOTABLE|MF_ENEMY --Punch bosses and other objects!
										P_DamageMobj(found, mo, mo)
									end--This kills the things
									//fuck this, kill saloon doors
									if found.valid
									and (found.type == MT_SALOONDOOR or found.type == MT_SALOONDOORCENTER) //the fuck
									and not found.deadlol
										found.flags = $ | MF_NOCLIP
										if found.type == MT_SALOONDOOR
											P_KillMobj(found)
											S_StartSound(p.mo,sfx_wbreak)
											S_StartSound(p.mo,sfx_s3k59)
										else
											RGA_funnyExplode(found)
											found.deadlol = true
										end
									end
								end
							end, p.mo, px-br, px+br, py-br, py+br)
							p.mo.state = S_PLAY_ROLL --speen
							ShieldAction(p, 1)--Do all this stuff, and you can use your hammer
						end
						p.rga.rga_jumpdown = (p.cmd.buttons & BT_JUMP)
						p.rga.rga_spindown = (p.cmd.buttons & BT_SPIN)
					else
						p.powers[pw_nights_superloop] = 1
						p.powers[pw_nights_helper] = 1
						p.powers[pw_nights_linkfreeze] = 1
						p.drillmeter = P_RandomRange(2, 1000) --im bored, ok?
					end
				else
					P_SpawnMobjFromMobj(p.mo,
					P_RandomRange(32, -32)*FRACUNIT,
					P_RandomRange(32, -32)*FRACUNIT,
					P_RandomKey(p.mo.height/FRACUNIT)*FRACUNIT, MT_DUST)
					p.mo.rollangle = $ + FixedAngle(abs(p.mo.momz))
				end
			else
				p.isuselesschar = false
				p.rga = nil
			end
		end
	end
end)

-- misc stuff (abilities)

addHook("MobjMoveBlocked", function(mo)
	if mo and mo.valid
	and mo.player and mo.player.valid
	and mo.skin == "rosegoldamy"
	and mo.state == S_PLAY_TWINSPIN
	and (mo.frame&FF_FRAMEMASK) < E 
	and not mo.player.rga.cantspin
		ShieldAction(mo.player, 2)
		mo.player.drawangle = $ + ANGLE_180
	end
end, MT_PLAYER) --Boink, you can use the hammer again! Get a vertical boost too!

addHook("SpinSpecial", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "rosegoldamy"
	and p.pflags & PF_JUMPED
	and not (p.pflags & PF_USEDOWN)
	and not p.powers[pw_carry]
		if not p.rga.dothing
		and not p.rga.cantspin
			p.mo.frame = A
			p.mo.state = S_PLAY_TWINSPIN
			//p.dothing = true
			p.rga.cantspin = true
			ShieldAction(p, 3)
		end --Drop-thok twinspin!! Allows you to crash down and kill things
	end
end)

addHook("AbilitySpecial", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "rosegoldamy"
		if not p.rga.dothing
		and not p.powers[pw_carry]
		and not (p.pflags & (PF_SLIDING|PF_JUMPSTASIS))
			RGA_doubleJump(p)
			return true
		end --Doublejump twinspin!!
	end
end)

addHook("PlayerCanDamage", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "rosegoldamy"
		if p.mo.state == S_PLAY_ROLL
			return true
		end --Speeeeeeen
	end
end)

//Lach was here
local function RGAHeight(player)
  local mo = player.mo
  if mo.skin == 'rosegoldamy'
  and mo.state == S_PLAY_TWINSPIN
    return P_GetPlayerSpinHeight(player)
  end
end

addHook("PlayerHeight", RGAHeight)
addHook("PlayerCanEnterSpinGaps", RGAHeight)

-- death

addHook("MobjDeath", function(mo)
	if mo and mo.valid
	and mo.player and mo.player.valid
		if mo.skin == "rosegoldamy"
			for i = 1, 16 do
				P_SpawnParaloop(mo.x, mo.y, mo.z + (mo.height/2), mo.radius*4, 16, MT_NIGHTSPARKLE, i*(ANGLE_22h), S_NULL, true)
			end
		end
	end
end, MT_PLAYER) --death


addHook("ShouldDamage", function(mo, source, inflictor, damage, damagetype)
	if mo and mo.valid
	and mo.player and mo.player.valid
		if mo.skin == "rosegoldamy"
		and (mo.state == S_PLAY_TWINSPIN
		and (mo.frame&FF_FRAMEMASK) < E
		and !(damagetype & DMG_DEATHMASK))
		or mo.state == S_PLAY_MELEE_LANDING
			return false
		end
	end
end, MT_PLAYER)
